<?php
// -- Include js files
if ( ! function_exists('gs_enqueue_pinterest_scripts') ) {
	function gs_enqueue_pinterest_scripts() {
		if (!is_admin()) {

			// //chick if jquery easing is already registred or not
			if( !wp_script_is('gspin-mfp-js', 'registered') ) {
			wp_register_script('gspin-mfp-js', GSPIN_FILES_URI . '/assets/js/jquery.magnific-popup.min.js', array('jquery'), GSPIN_VERSION, true);
			}
			// // chick if jquery easing is already enqueued or not
			if(!wp_script_is('gspin-mfp-js', 'enqueued' )) {
				wp_enqueue_script('gspin-mfp-js');
			}

			wp_register_script('gsp-jquery-masonry', GSPIN_FILES_URI . '/assets/js/masonry.pkgd.min.js', array('jquery'), GSPIN_VERSION, false);
			wp_enqueue_script('gsp-jquery-masonry');


			wp_register_script('gspin-grey-js', GSPIN_FILES_URI . '/assets/js/jquery.gray.min.js', array('jquery'), GSPIN_VERSION, true);
			wp_enqueue_script('gspin-grey-js');

			wp_register_script('gspin-img-loaded-js', GSPIN_FILES_URI . '/assets/js/imagesloaded.pkgd.min.js', array('jquery'), GSPIN_VERSION, true);
			wp_enqueue_script('gspin-img-loaded-js');


			wp_register_script( 'pinterest-pinit-js', '//assets.pinterest.com/js/pinit.js', array(), GSPIN_VERSION, true );
			wp_enqueue_script('pinterest-pinit-js');			
		}	
	}
	add_action( 'wp_enqueue_scripts', 'gs_enqueue_pinterest_scripts' ); 
}

// -- Include css files
if ( ! function_exists('gs_enqueue_pinterest_styles') ) {
	function gs_enqueue_pinterest_styles() {
		if (!is_admin()) {
			$media = 'all';

			if(!wp_style_is('gspin-fa-icons','registered')){
				wp_register_style('gspin-fa-icons', GSPIN_FILES_URI . '/assets/fa-icons/css/font-awesome.min.css','', GSPIN_VERSION, $media);
			}
			if(!wp_style_is('gspin-fa-icons','enqueued')){
				wp_enqueue_style('gspin-fa-icons');
			}

			if(!wp_style_is('gspin-mfp-css','registered')){
				wp_register_style('gspin-mfp-css', GSPIN_FILES_URI . '/assets/css/magnific-popup.css', '', GSPIN_VERSION, $media);
			}
			if(!wp_style_is('gspin-mfp-css','enqueued')){
				wp_enqueue_style('gspin-mfp-css');
			}

			// Plugin main stylesheet
			wp_register_style('gs_pin_custom_css', GSPIN_FILES_URI . '/assets/css/gs-pin-custom.css','', GSPIN_VERSION, $media);
			wp_enqueue_style('gs_pin_custom_css');			
		}
	}
	add_action( 'init', 'gs_enqueue_pinterest_styles' );
}

// -- Pinterest Custom CSS
if ( !function_exists('gs_pinterest_custom_style')) {
	function gs_pinterest_custom_style() {

		$gs_pin_custom_css = gs_pinterest_getoption('gs_pin_custom_css', 'gs_pinterest_settings', '');

		if( isset($gs_pin_custom_css) && !empty($gs_pin_custom_css) ){
			?>
				<style type="text/css"><?php echo $gs_pin_custom_css;?></style>
			<?php
		}
	}
	add_action( 'gs_pinterest_custom_css','gs_pinterest_custom_style' );
}